package com.bergerkiller.bukkit.nolagg.logging;

public class TimedWrapper implements Runnable {
	
	public final Runnable runnable;
	private final TaskMeasurement dest;
	public TimedWrapper(final Runnable runnable, final TaskMeasurement dest) {
		this.runnable = runnable;
		this.dest = dest;
	}
		
	public void run() {
		if (PluginLogger.position > PluginLogger.duration - 1) {
			this.runnable.run();
		} else {
			long time = System.nanoTime();
			this.runnable.run();
			try {
				this.dest.times[PluginLogger.position] += System.nanoTime() - time;
			} catch (ArrayIndexOutOfBoundsException ex) {}
		}
	}
	
}
