package com.bergerkiller.bukkit.nolaggtnt;

import org.bukkit.ChatColor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.permissions.PermissionDefault;

import com.bergerkiller.bukkit.common.PluginBase;
import com.bergerkiller.bukkit.common.Task;
import com.bergerkiller.bukkit.common.config.FileConfiguration;

public class NoLaggTNT extends PluginBase {

	public static NoLaggTNT plugin;
	
	public NoLaggTNT() {
		super(1838, 2000);
	}

	@Override
	public void enable() {
		plugin = this;
		
		new Task(this) {
			public void run() {
				plugin.register(NLTListener.class);
			}
		}.start(1);
		this.register("tnt");
		
		FileConfiguration config = new FileConfiguration(this);
		config.load();
		
		//tnt
		config.setHeader("This is the configuration of NoLaggTNT\n");
		config.setHeader("detonationInterval", "The interval (in ticks) at which TNT is detonated by explosions");
		config.setHeader("detonationRate", "How many TNT is detonated by explosions per interval");
		config.setHeader("explosionRadiusFactor", "The explosion crater size factor");
		config.setHeader("explosionRate", "The amount of explosion packets to send to the clients per tick");
		config.setHeader("changeBlocks", "If TNT explosions can change non-TNT blocks");

		TnTHandler.interval = config.get("detonationInterval", 1);
		TnTHandler.rate = config.get("detonationRate", 10);
		CustomExplosion.factor = config.get("explosionRadiusFactor", 1.0);
		TnTHandler.explosionRate = config.get("explosionRate", 5);
		TnTHandler.changeBlocks = config.get("changeBlocks", true);
		
		config.save();
		
		TnTHandler.init();
	}

	@Override
	public void disable() {
		TnTHandler.deinit();
	}

	@Override
	public boolean command(CommandSender sender, String command, String[] args) {
		if (command.equalsIgnoreCase("tnt")) {
			if (args.length == 1 && args[0].equalsIgnoreCase("clear")) {
				if (sender instanceof Player) {
					if (!sender.hasPermission("nolaggtnt.clear")) {
						sender.sendMessage(ChatColor.RED + "You don't have permission!");						
						return true;
					}
				}
				TnTHandler.clear();
				sender.sendMessage("TNT detonation stopped, pending TNT cleared");
			} else {
				if (sender instanceof Player) {
					if (!sender.hasPermission("nolaggtnt.info")) {
						sender.sendMessage(ChatColor.RED + "You don't have permission!");						
						return true;
					}
				}
				sender.sendMessage(TnTHandler.getBufferCount() + " TNT blocks are waiting for detonation");
			}
		}
		return true;
	}
	
	@Override
	public void permissions() {
		this.loadPermission("nolaggtnt.info", PermissionDefault.OP, "The player can show TNT information");
		this.loadPermission("nolaggtnt.clear", PermissionDefault.OP, "The player can stop TNT detonation");
	}

}
